<section class="gl-container">
  <form [formGroup]="glFormGroup" #glForm="ngForm">
    <mat-form-field appearance="standard">
      <mat-label>Date</mat-label>
      <input matInput readonly [max]="today" (click)="cfdpicker.open()" [matDatepicker]="cfdpicker"
        formControlName="date" (dateChange)="getPeriodData()">
      <mat-datepicker-toggle matSuffix [for]="cfdpicker"></mat-datepicker-toggle>
      <mat-datepicker #cfdpicker></mat-datepicker>
    </mat-form-field>
    <div class="period-field">
      <mat-form-field appearance="standard">
        <mat-label>Fiscal Period</mat-label>
        <input type="number" matInput placeholder="Month" (keyup)="checkLimit($event, 'fiscalMonth')"
          formControlName="fiscalMonth" required maxlength="2" disabled>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <input type="number" matInput maxlength="4" (keyup)="checkLimit($event, 'fiscalYear')" placeholder="Year"
          formControlName="fiscalYear" required disabled>
      </mat-form-field>
    </div>
    <div class="period-field">
      <mat-form-field appearance="standard">
        <mat-label>Tax Period</mat-label>
        <input type="number" matInput placeholder="Month" (keyup)="checkLimit($event, 'taxMonth')"
          formControlName="taxMonth" required maxlength="2" disabled>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <input type="number" matInput placeholder="Year" (keyup)="checkLimit($event, 'taxYear')"
          formControlName="taxYear" required disabled>
      </mat-form-field>
    </div>
    <mat-form-field appearance="standard">
      <mat-label>Transaction</mat-label>
      <mat-select name="itemCode" formControlName="transaction">
        <mat-option *ngFor="let transaction of transactions" [value]="transaction.code"
          (click)="updateTransaction(transaction)">
          {{transaction.code}} - {{transaction.description}}
        </mat-option>
      </mat-select>
    </mat-form-field>
    <mat-form-field appearance="standard">
      <mat-label>Description</mat-label>
      <input matInput placeholder="Description" formControlName="description" required maxlength="50">
    </mat-form-field>
    <mat-form-field appearance="standard">
      <mat-label>Currency</mat-label>
      <mat-select name="currency" formControlName="currency">
        <mat-option *ngFor="let currency of currencies" [value]="currency">
          {{currency}}
        </mat-option>
      </mat-select>
    </mat-form-field>
    <mat-form-field appearance="standard">
      <mat-label>Drafted GL</mat-label>
      <mat-select name="draftedGl" formControlName="draftedGl">
        <mat-option *ngFor="let draftedGl of draftedGls" [value]="draftedGl" (click)="updateDraftedGl(draftedGl)">
          {{draftedGl.code}}
        </mat-option>
      </mat-select>
    </mat-form-field>
    <div class="transaction-lists">
      <ul>
        <li *ngFor="let transaction of transactionsArr.controls; let i = index" [formGroup]="transaction">
          <span class="s-no">{{i+1}}</span>
          <mat-form-field class='sub-list' *ngIf="showAsset">
            <mat-label>Asset Code</mat-label>
            <mat-select name="asset" formControlName="asset">
              <ng-container *ngFor="let asset of assets">
                <mat-option [value]="asset.assetCode"
                  (click)="checkAssets(i, asset)">
                  {{asset.assetCode}} - {{asset.description}}
                </mat-option>
                </ng-container>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Ledger</mat-label>
            <mat-select name="ledger" formControlName="ledger">
              <ng-container *ngFor="let ledger of ledgers">
                <mat-option *ngIf="ledger.subLevel === '0'" [value]="ledger.accountNumber"
                  (click)="getLedgerDetails(i)">
                  {{ledger.accountNumber}} - {{ledger.description}}
                </mat-option>
                </ng-container>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Customer</mat-label>
            <mat-select name="customer" formControlName="customer">
              <mat-option (click)="onUnSelect(i, 'customer')">Select</mat-option>
              <mat-option *ngFor="let customer of customers" [value]="customer.bpCode" (onSelectionChange)="updateRequiredField($event, 'customer', i)">
                {{customer.bpCode}} - {{customer.name}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Supplier</mat-label>
            <mat-select name="supplier" formControlName="supplier">
              <mat-option (click)="onUnSelect(i, 'supplier')">Select</mat-option>
              <mat-option *ngFor="let supplier of supliers" [value]="supplier.bpCode" (onSelectionChange)="updateRequiredField($event, 'supplier', i)">
                {{supplier.bpCode}} - {{supplier.name}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field *ngIf="setMandInvNumFalse">
            <mat-label>Invoice Number</mat-label>
            <input matInput placeholder="Invoice Number" formControlName="invoiceNumber">
          </mat-form-field>
          <mat-form-field *ngIf="!setMandInvNumFalse">
            <mat-label>Invoice Number</mat-label>
            <input matInput placeholder="Invoice Number" formControlName="invoiceNumber" required>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Line of Business</mat-label>
            <mat-select name="dimen1" formControlName="dimen1">
              <mat-option (click)="onUnSelect(i, 'dimen1')">Select</mat-option>
              <ng-container *ngFor="let dimension of dimensions">
                <mat-option *ngIf="dimension?.dimensionType === 'Line_Of_Business'" [value]="dimension.code">
                  {{dimension.code}} - {{dimension.description}}
                </mat-option>
              </ng-container>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Item Group</mat-label>
            <mat-select name="dimen2" formControlName="dimen2">
              <mat-option (click)="onUnSelect(i, 'dimen2')">Select</mat-option>
              <ng-container *ngFor="let dimension of dimensions">
                <mat-option *ngIf="dimension?.dimensionType === 'Item_Group'" [value]="dimension.code">
                  {{dimension.code}} - {{dimension.description}}
                </mat-option>
              </ng-container>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Project</mat-label>
            <mat-select name="dimen3" formControlName="dimen3">
              <mat-option (click)="onUnSelect(i, 'dimen3')">Select</mat-option>
              <ng-container *ngFor="let dimension of dimensions">
                <mat-option *ngIf="dimension?.dimensionType === 'Project'" [value]="dimension.code">
                  {{dimension.code}} - {{dimension.description}}
                </mat-option>
              </ng-container>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Department</mat-label>
            <mat-select name="dimen4" formControlName="dimen4">
              <mat-option (click)="onUnSelect(i, 'dimen4')">Select</mat-option>
              <ng-container *ngFor="let dimension of dimensions">
                <mat-option *ngIf="dimension?.dimensionType === 'Department'" [value]="dimension.code">
                  {{dimension.code}} - {{dimension.description}}
                </mat-option>
              </ng-container>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Employee Miscellaneous</mat-label>
            <mat-select name="dimen5" formControlName="dimen5">
              <mat-option (click)="onUnSelect(i, 'dimen5')">Select</mat-option>
              <ng-container *ngFor="let dimension of dimensions">
                <mat-option *ngIf="dimension?.dimensionType === 'Employee_Miscellaneous'" [value]="dimension.code">
                  {{dimension.code}} - {{dimension.description}}
                </mat-option>
              </ng-container>
            </mat-select>
          </mat-form-field>
          <!-- <mat-form-field class='sub-list'>
            <mat-label>Currency</mat-label>
            <mat-select name="currency" formControlName="currency">
              <mat-option *ngFor="let currency of currencies" [value]="currency">
                {{currency}}
              </mat-option>
            </mat-select>
          </mat-form-field> -->


          <!-- <mat-form-field class='sub-list'>
            <mat-label>Amount</mat-label>
            <input matInput placeholder="Amount" formControlName="amount" (keyup)="checkAmount()" required>
          </mat-form-field> -->
          <mat-form-field>
            <mat-label>VAT Code</mat-label>
            <mat-select name="vatCode" formControlName="vatCode">
              <mat-option *ngFor="let vat of vatCodes" [value]="vat.vatCode" (click)="updateVat(i, vat.vatPercentage)">
                {{vat.vatCode}} - {{vat.vatDescription}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field>
            <mat-label>VAT %</mat-label>
            <input matInput placeholder="VAT Percentage " (keyup)="updateAmount(i)" formControlName="vatPercentage" required>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Gross Amount</mat-label>
            <input matInput placeholder="Gross Amount " (keyup)="updateAmount(i)" formControlName="amount" required>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Net Amount</mat-label>
            <input matInput type="number" placeholder="Net Amount" formControlName="grandtotalprice" (keyup)="checkAmount()"
              required disabled>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Type</mat-label>
            <mat-select name="type" formControlName="type">
              <mat-option *ngFor="let type of types" [value]="type" (click)="checkAmount()">
                {{type}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field class='sub-list'>
            <mat-label>Narration</mat-label>
            <input matInput placeholder="Narration" formControlName="narration" maxlength="50">
          </mat-form-field>
          <div class="remove-action">
            <button type="reset" mat-mini-fab class="add-remove-item remove" (click)="removeTransaction(i)">-</button>
          </div>
        </li>
      </ul>
    </div>
    <div class="add-action">
      <span><button mat-mini-fab (click)="addTransaction()">+</button></span> <span class="text-btn">Add
        Transaction</span>
    </div>
    <div class="btn-group">
      <!-- <button mat-button [disabled]="!glFormGroup.valid || transactionsArr.controls.length === 0"
        (click)="submitGL('save')">Save</button> -->
      <button mat-button [disabled]="transactionsArr.controls.length === 0 || !isEnteredAmt"
        (click)="submitGL('save')">Save</button> {{glFormGroup.value.amount}}
      <button mat-button [disabled]="!glFormGroup.valid || transactionsArr.controls.length === 0 || doNotShowSumbit"
        (click)="submitGL('submit')">Submit</button>
    </div>
    <div class="btn-group">
      <button (click)="onDownloadTemplate($event)" mat-button>Download</button>
      <input #excelInput hidden="true" type="file" onclick="this.value=null" (change)="onUploadFile($event)"
        accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel" />
      <button mat-raised-button color="primary" (click)="excelInput.click()" class="xl-btn">Upload</button>
    </div>
  </form>
</section>